## ros2-osrf-testing-tools-cpp 1.5.1+ds

=== debian/changelog ===
ros2-osrf-testing-tools-cpp (1.5.1+ds-2) unstable; urgency=medium

  * Source only upload.

 -- Timo Röhling <roehling@debian.org>  Thu, 02 Jun 2022 11:18:49 +0200

ros2-osrf-testing-tools-cpp (1.5.1+ds-1) unstable; urgency=medium

  * Initial release (Closes: #1011959)

 -- Timo Röhling <roehling@debian.org>  Sun, 29 May 2022 22:58:25 +0200

=== debian/rules ===
#!/usr/bin/make -f

export ROS_CONFIGURE_ARGS = -DMEMORY_TOOLS_SOVERSION=0d

%:
	dh $@ --buildsystem=ros

## ros2-osrf-testing-tools-cpp 1.5.2%2Bds

=== osrf_testing_tools_cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(osrf_testing_tools_cpp)

set(osrf_testing_tools_cpp_VERSION 1.5.1)

# Default to C++11
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 11)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic
  -Wformat=2 -Wconversion -Woverloaded-virtual
  -Wshadow -Wnon-virtual-dtor)
endif()

add_subdirectory(src)

include(CTest)
if(BUILD_TESTING)
  include(cmake/osrf_testing_tools_cpp_require_googletest.cmake)
  # ensures target gtest_main exists
  osrf_testing_tools_cpp_require_googletest(VERSION_GTE 1.10
    VENDOR_DIR "${CMAKE_SOURCE_DIR}/vendor")

  add_subdirectory(test)
endif()

configure_file(osrf_testing_tools_cppConfig.cmake.in
  "${PROJECT_BINARY_DIR}/osrf_testing_tools_cppConfig.cmake" @ONLY)
configure_file(osrf_testing_tools_cppConfigVersion.cmake.in
  "${PROJECT_BINARY_DIR}/osrf_testing_tools_cppConfigVersion.cmake" @ONLY)

install(FILES
  "${PROJECT_BINARY_DIR}/osrf_testing_tools_cppConfig.cmake"
  "${PROJECT_BINARY_DIR}/osrf_testing_tools_cppConfigVersion.cmake"
  DESTINATION share/${PROJECT_NAME}/cmake
)

install(DIRECTORY vendor/
  DESTINATION share/${PROJECT_NAME}/vendor
  PATTERN ".gitattributes" EXCLUDE
)

install(DIRECTORY cmake/
  DESTINATION share/${PROJECT_NAME}/cmake
)

install(
  DIRECTORY include/
  DESTINATION include
)

install(FILES
  package.xml
  DESTINATION share/${PROJECT_NAME})

=== osrf_testing_tools_cpp/test/memory_tools/CMakeLists.txt ===
# Create tests for the memory tools library.
add_executable(test_memory_tools test_memory_tools.cpp)
target_link_libraries(test_memory_tools
  memory_tools
  gtest_main
)
target_include_directories(test_memory_tools
  PRIVATE ${memory_tools_src_dir_internal_testing_only})

if(memory_tools_is_available)
  add_test(
    NAME "test_memory_tools"
    COMMAND
      "$<TARGET_FILE:test_runner>"
      --env
        ${memory_tools_extra_test_env}
      --
      "$<TARGET_FILE:test_memory_tools>"
  )
endif()

## ros2-osrf-testing-tools-cpp 1.5.2+ds

=== test_osrf_testing_tools_cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(test_osrf_testing_tools_cpp)

# Default to C++11
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 11)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

include(CTest)
if(BUILD_TESTING)
  find_package(osrf_testing_tools_cpp REQUIRED)
  osrf_testing_tools_cpp_require_googletest(VERSION_GTE 1.8)  # ensures target gtest_main exists
  get_target_property(memory_tools_available
    osrf_testing_tools_cpp::memory_tools LIBRARY_PRELOAD_ENVIRONMENT_IS_AVAILABLE)

  if(memory_tools_available)
    add_executable(test_example_memory_tools_gtest test/test_example_memory_tools.cpp)
    target_link_libraries(test_example_memory_tools_gtest
      gtest_main
      osrf_testing_tools_cpp::memory_tools
    )
    get_target_property(extra_env_vars
      osrf_testing_tools_cpp::memory_tools LIBRARY_PRELOAD_ENVIRONMENT_VARIABLE)
    osrf_testing_tools_cpp_add_test(test_example_memory_tools
      COMMAND "$<TARGET_FILE:test_example_memory_tools_gtest>"
      ENV ${extra_env_vars}
    )

    add_executable(test_is_not_working_gtest test/test_is_not_working.cpp)
    target_link_libraries(test_is_not_working_gtest
      gtest_main
      osrf_testing_tools_cpp::memory_tools
    )
    osrf_testing_tools_cpp_add_test(test_is_not_working_gtest
      COMMAND "$<TARGET_FILE:test_is_not_working_gtest>"
    )
  endif()
endif()

=== osrf_testing_tools_cpp/src/CMakeLists.txt ===
add_subdirectory(memory_tools)
add_subdirectory(test_runner)

set(memory_tools_extra_test_env "${memory_tools_extra_test_env}" PARENT_SCOPE)
set(memory_tools_is_available "${memory_tools_is_available}" PARENT_SCOPE)
set(memory_tools_src_dir_internal_testing_only
  "${memory_tools_src_dir_internal_testing_only}" PARENT_SCOPE)

=== osrf_testing_tools_cpp/test/CMakeLists.txt ===
add_subdirectory(cmake)
add_subdirectory(memory_tools)
add_subdirectory(test_runner)

=== osrf_testing_tools_cpp/src/memory_tools/CMakeLists.txt ===
# Integrate backward-cpp according to:
#   https://github.com/bombela/backward-cpp/tree/v1.5#modifying-cmake_module_path

# Note, I had to use Backward_DIR since they provide a config file rather than a module...
# list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/vendor/bombela/backward-cpp")
set(Backward_DIR "${CMAKE_CURRENT_SOURCE_DIR}/vendor/bombela/backward-cpp")
set(FPHSA_NAME_MISMATCHED TRUE)
find_package(Backward REQUIRED)
unset(FPHSA_NAME_MISMATCHED)

add_library(memory_tools SHARED
  custom_memory_functions.cpp
  implementation_monitoring_override.cpp
  initialize.cpp
  is_working.cpp
  memory_tools_service.cpp
  monitoring.cpp
  register_hooks.cpp
  stack_trace.cpp
  testing_helpers.cpp
  verbosity.cpp
)

target_include_directories(memory_tools
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)
target_link_libraries(memory_tools PRIVATE Backward::Backward)

if(CMAKE_DL_LIBS)
  target_link_libraries(memory_tools PUBLIC ${CMAKE_DL_LIBS})
endif()

target_compile_definitions(memory_tools
  PRIVATE "OSRF_TESTING_TOOLS_CPP_MEMORY_TOOLS_BUILDING_DLL")

add_library(memory_tools_interpose SHARED
  memory_tools.cpp
)
target_link_libraries(memory_tools_interpose memory_tools)

option(OSRF_TESTING_TOOLS_CPP_DISABLE_MEMORY_TOOLS
  "Disable environment configuration for memory tools"
  OFF)

# Memory tools doesn't work on Windows right now.
# TODO(wjwwood): If on aarch64, so not set the preload environment variables, until fixed.
# see: https://github.com/osrf/osrf_testing_tools_cpp/issues/3
if(WIN32 OR CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64")
  set(OSRF_TESTING_TOOLS_CPP_DISABLE_MEMORY_TOOLS ON)
endif()

if (NOT OSRF_TESTING_TOOLS_CPP_DISABLE_MEMORY_TOOLS)
  set(memory_tools_is_available TRUE)
  if(APPLE)
    list(APPEND memory_tools_extra_test_env
      DYLD_INSERT_LIBRARIES=$<TARGET_FILE:memory_tools_interpose>)
  elseif(UNIX)
    list(APPEND memory_tools_extra_test_env
      LD_PRELOAD=$<TARGET_FILE:memory_tools_interpose>)
  endif()
endif()

install(TARGETS memory_tools
  EXPORT memory_tools
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

install(EXPORT memory_tools
  DESTINATION share/${PROJECT_NAME}/cmake
  NAMESPACE "${PROJECT_NAME}::"
  FILE "memory_toolsExport.cmake"
)

install(TARGETS memory_tools_interpose
  EXPORT memory_tools_interpose
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

install(EXPORT memory_tools_interpose
  DESTINATION share/${PROJECT_NAME}/cmake
  NAMESPACE "${PROJECT_NAME}::"
  FILE "memory_tools_interposeExport.cmake"
)

set(memory_tools_extra_test_env "${memory_tools_extra_test_env}" PARENT_SCOPE)
set(memory_tools_is_available "${memory_tools_is_available}" PARENT_SCOPE)
set(memory_tools_src_dir_internal_testing_only
  "$<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src>" PARENT_SCOPE)

=== osrf_testing_tools_cpp/src/test_runner/CMakeLists.txt ===
add_executable(test_runner main.cpp)

install(TARGETS test_runner
  EXPORT test_runner
  DESTINATION lib/${PROJECT_NAME}
)

install(EXPORT test_runner
  DESTINATION share/${PROJECT_NAME}/cmake
  NAMESPACE "${PROJECT_NAME}::"
  FILE "test_runnerExport.cmake"
)

=== osrf_testing_tools_cpp/test/cmake/CMakeLists.txt ===
# Test logic for version filtering when selecting googletest version.
add_test(
  NAME "test_osrf_testing_tools_cpp_filter_versions_cmake"
  COMMAND
    ${CMAKE_COMMAND} -P
    "${CMAKE_SOURCE_DIR}/test/cmake/test_osrf_testing_tools_cpp_filter_versions.cmake"
)

=== debian/changelog ===
ros2-osrf-testing-tools-cpp (1.5.2+ds-1) unstable; urgency=medium

  * New upstream version 1.5.2+ds
  * Update patches
    - Drop Fix-FTBFS-with-GCC-12.patch (merged upstream)

 -- Timo Röhling <roehling@debian.org>  Thu, 10 Nov 2022 20:50:27 +0100

ros2-osrf-testing-tools-cpp (1.5.1+ds-4) unstable; urgency=medium

  * Link against libatomic on riscv64

 -- Timo Röhling <roehling@debian.org>  Mon, 01 Aug 2022 20:12:10 +0200

ros2-osrf-testing-tools-cpp (1.5.1+ds-3) unstable; urgency=medium

  * Fix FTBFS with GCC-12

 -- Timo Röhling <roehling@debian.org>  Thu, 16 Jun 2022 20:56:54 +0200

=== debian/control ===
Source: ros2-osrf-testing-tools-cpp
Section: libs
Priority: optional
Maintainer: Debian Robotics Team <team+robotics@tracker.debian.org>
Uploaders: Timo Röhling <roehling@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 dh-ros,
 libbackward-cpp-dev,
 libgtest-dev <!nocheck>,
Homepage: https://github.com/osrf/osrf_testing_tools_cpp
Standards-Version: 4.6.1
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/robotics-team/ros2-osrf-testing-tools-cpp.git
Vcs-Browser: https://salsa.debian.org/robotics-team/ros2-osrf-testing-tools-cpp
Description: OSRF testing tools for ROS 2
 This package is part of ROS 2, the Robot Operating System.
 The Open Source Robotics Foundation testing tools provide a framework for
 testing C++ code.

Package: libosrf-memory-tools0d
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package installs the memory_tools shared libraries.

Package: libosrf-testing-tools-cpp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libosrf-memory-tools0d (= ${binary:Version}),
Description: ${source:Synopsis} (development files)
 ${source:Extended-Description}
 .
 This package installs the CMake config files and public headers.

## ros2-osrf-testing-tools-cpp 1.7.0+ds

=== osrf_testing_tools_cpp/CMakeLists.txt ===
--- 
+++ 
@@ -4,9 +4,9 @@
 
 set(osrf_testing_tools_cpp_VERSION 1.5.1)
 
-# Default to C++11
+# Default to C++17
 if(NOT CMAKE_CXX_STANDARD)
-  set(CMAKE_CXX_STANDARD 11)
+  set(CMAKE_CXX_STANDARD 17)
 endif()
 
 if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")

=== test_osrf_testing_tools_cpp/CMakeLists.txt ===
--- 
+++ 
@@ -2,9 +2,9 @@
 
 project(test_osrf_testing_tools_cpp)
 
-# Default to C++11
+# Default to C++17
 if(NOT CMAKE_CXX_STANDARD)
-  set(CMAKE_CXX_STANDARD 11)
+  set(CMAKE_CXX_STANDARD 17)
 endif()
 
 if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")

=== debian/changelog ===
ros2-osrf-testing-tools-cpp (1.7.0+ds-1) unstable; urgency=medium

  * New upstream version 1.7.0+ds

 -- Timo Röhling <roehling@debian.org>  Sat, 24 Jun 2023 16:39:13 +0200

## ros2-osrf-testing-tools-cpp 2.1.0+ds

=== debian/changelog ===
ros2-osrf-testing-tools-cpp (2.1.0+ds-1) unstable; urgency=medium

  * New upstream version 2.1.0+ds

 -- Timo Röhling <roehling@debian.org>  Mon, 29 Apr 2024 00:34:04 +0200

ros2-osrf-testing-tools-cpp (2.0.0+ds-1) unstable; urgency=medium

  * New upstream version 2.0.0+ds
  * Update patches
    - Drop De-vendor-variant.hpp.patch (obsolete)
  * Bump Standards-Version to 4.7.0

 -- Timo Röhling <roehling@debian.org>  Wed, 10 Apr 2024 22:31:31 +0200

## ros2-osrf-testing-tools-cpp 2.2.0+ds

=== osrf_testing_tools_cpp/CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 if(BUILD_TESTING)
   include(cmake/osrf_testing_tools_cpp_require_googletest.cmake)
   # ensures target gtest_main exists
-  osrf_testing_tools_cpp_require_googletest(VERSION_GTE 1.10
+  osrf_testing_tools_cpp_require_googletest(VERSION_GTE 1.14
     VENDOR_DIR "${CMAKE_SOURCE_DIR}/vendor")
 
   add_subdirectory(test)

=== test_osrf_testing_tools_cpp/CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,7 @@
 include(CTest)
 if(BUILD_TESTING)
   find_package(osrf_testing_tools_cpp REQUIRED)
-  osrf_testing_tools_cpp_require_googletest(VERSION_GTE 1.8)  # ensures target gtest_main exists
+  osrf_testing_tools_cpp_require_googletest(VERSION_GTE 1.14)  # ensures target gtest_main exists
   get_target_property(memory_tools_available
     osrf_testing_tools_cpp::memory_tools LIBRARY_PRELOAD_ENVIRONMENT_IS_AVAILABLE)

=== osrf_testing_tools_cpp/src/memory_tools/CMakeLists.txt ===
--- 
+++ 
@@ -47,7 +47,7 @@
 # Memory tools doesn't work on Windows right now.
 # TODO(wjwwood): If on aarch64, so not set the preload environment variables, until fixed.
 # see: https://github.com/osrf/osrf_testing_tools_cpp/issues/3
-if(WIN32 OR CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64")
+if(WIN32 OR CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64" OR CMAKE_SYSTEM_PROCESSOR STREQUAL "arm64")
   set(OSRF_TESTING_TOOLS_CPP_DISABLE_MEMORY_TOOLS ON)
 endif()

=== osrf_testing_tools_cpp/test/test_runner/CMakeLists.txt ===
# Test parsing of environment variables
add_executable(test_parse_environment_variable test_parse_environment_variable.cpp)
# gtest_main is found by osrf_testing_tools_cpp_require_googletest(), called in main CMakeLists.txt
target_link_libraries(test_parse_environment_variable gtest_main)
add_test(
  NAME "test_parse_environment_variable"
  COMMAND "$<TARGET_FILE:test_parse_environment_variable>"
)

# Test the test_runner's ability to influence environment variables in tests
add_executable(assert_env_vars assert_env_vars.cpp)
# gtest_main is found by osrf_testing_tools_cpp_require_googletest(), called in main CMakeLists.txt
target_link_libraries(assert_env_vars gtest_main)

# The use of `:` in path-like env var's is converted to `;` by `assert_env_vars`.
add_test(
  NAME "test_test_runner"
  COMMAND
    "$<TARGET_FILE:test_runner>"
    --env
      FOO=bar
      PING=pong
    --append-env
      FOO=baz
    --
    "$<TARGET_FILE:assert_env_vars>"
    --env
      FOO=bar:baz
      PING=pong
)

# # This test can be uncommented to make sure a bad return code is propogated by test_runner.
# add_test(
#   NAME "test_test_runner_fails"
#   COMMAND
#     "$<TARGET_FILE:test_runner>"
#     --env
#       FOO=bar
#       PING=pong
#     --append-env
#       FOO=baz
#     --
#     python3 -c "import sys; print('exiting with code 1'); sys.exit(1)"
# )

=== debian/changelog ===
ros2-osrf-testing-tools-cpp (2.2.0+ds-1) unstable; urgency=medium

  * New upstream version 2.2.0+ds
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Fri, 12 Jul 2024 18:22:38 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  libbackward-cpp-dev,
  libgtest-dev <!nocheck>,
 Homepage: https://github.com/osrf/osrf_testing_tools_cpp
-Standards-Version: 4.6.1
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/robotics-team/ros2-osrf-testing-tools-cpp.git
 Vcs-Browser: https://salsa.debian.org/robotics-team/ros2-osrf-testing-tools-cpp

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

DEB_LINK_LIBATOMIC = $(if $(filter riscv64,$(DEB_HOST_ARCH)),ON,OFF)

export ROS_CONFIGURE_ARGS = -DMEMORY_TOOLS_SOVERSION=0d -DDEB_LINK_LIBATOMIC=$(DEB_LINK_LIBATOMIC)

%:
	dh $@ --buildsystem=ros

=== debian/watch ===
version=4
opts=filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%,dversionmangle=s/\+ds\d*$//,oversionmangle=s/$/+ds/,repack \
 https://github.com/osrf/osrf_testing_tools_cpp/tags (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
